package com.inteligr8.junit5;

import java.util.Collection;

import org.junit.jupiter.api.Assertions;

public class AssertCollection {
	
	public static void assertSize(int expectedCount, Collection<?> actualCollection) {
		assertSize(expectedCount, actualCollection, null);
	}
	
	public static void assertSize(int expectedCount, Collection<?> actualCollection, String message) {
		if (expectedCount == 0) Assertions.assertTrue(actualCollection == null || actualCollection.isEmpty(), message);
		else Assertions.assertTrue(actualCollection != null && actualCollection.size() == expectedCount, message);
	}
	
	public static <T> void assertContains(T expectedElement, Collection<T> actualCollection) {
		assertContains(expectedElement, actualCollection, null);
	}
	
	public static <T> void assertContains(Collection<T> expectedElements, Collection<T> actualCollection) {
		assertContains(expectedElements, actualCollection, null);
	}
	
	public static <T> void assertContains(T expectedElement, Collection<T> actualCollection, String message) {
		Assertions.assertTrue(actualCollection != null && actualCollection.contains(expectedElement), message);
	}
	
	public static <T> void assertContains(Collection<T> expectedElements, Collection<T> actualCollection, String message) {
		Assertions.assertTrue(actualCollection != null && actualCollection.containsAll(expectedElements), message);
	}

}
